/**
 * @license
 * DataWriterClient.js [object Object] <http://islog.com/>
 *
 * Copyright (c) 2016 by ISLOG (D3L SARL company)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without limitation the rights to use, copy, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom
 * the Software is furnished to do so, subject to the following conditions:
 *
 * * The above copyright notice and this permission notice shall be included in all
 *   copies or substantial portions of the Software. These notices are optional in
 *   all copies of the Distributed Software.
 * * The Software and its derivated work *must be used* with a web server provided
 *   and/or sold by ISLOG, or an official reseller. This web server is not free of
 *   charges and under its own licensing.
 *
 * Specific copyright and permission notices can be defined in a purchase
 * offer from ISLOG which overwrite any statement in this license file.
 * 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
 
(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.dwjs = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*jshint esversion: 6*/

var _DWUtils = _dereq_('./DWUtils');

var _DWUtils2 = _interopRequireDefault(_DWUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DWReadersProtocol = function () {
	function DWReadersProtocol() {
		_classCallCheck(this, DWReadersProtocol);

		this.DWReadersProtocolOperations = Object.getOwnPropertyNames(DWReadersProtocol.prototype);
	}

	_createClass(DWReadersProtocol, [{
		key: 'SendToBridge',
		value: function SendToBridge(obj) {
			var str = JSON.stringify(obj);
			_DWUtils2.default.log('Send to reader: ' + str);
			this.mProxyReader.send(str); //forward to bridge
		}
	}, {
		key: 'DoIt',
		value: function DoIt(obj) {
			if ($.inArray(obj.Method, this.DWReadersProtocolOperations) !== -1) {
				this[obj.Method](obj);
			} else {
				this.SendToBridge(obj); //forward to bridge
			}
		}
	}, {
		key: 'WebSocketReaders',
		set: function set(eWebSocketReaders) {
			this.mWSReaders = eWebSocketReaders;
		},
		get: function get() {
			return this.mWSReaders;
		}
	}, {
		key: 'ProxyReader',
		get: function get() {
			return this.mProxyReader;
		},
		set: function set(eProxyReader) {
			this.mProxyReader = eProxyReader;
		}
	}]);

	return DWReadersProtocol;
}();

exports.default = DWReadersProtocol;

},{"./DWUtils":4}],2:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*jshint esversion: 6*/

var _DWUtils = _dereq_('./DWUtils');

var _DWUtils2 = _interopRequireDefault(_DWUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DWSessionsProtocol = function () {
	function DWSessionsProtocol(options) {
		_classCallCheck(this, DWSessionsProtocol);

		this.options = options;
		this.DWSessionsProtocolOperations = Object.getOwnPropertyNames(DWSessionsProtocol.prototype);
	}

	_createClass(DWSessionsProtocol, [{
		key: 'CreateSessionCompleted',
		value: function CreateSessionCompleted(obj) {
			obj.Method = 'AttachToSessionAsync';

			var msg = {
				Method: 'AttachToSessionAsync',
				Parameters: [{ 'Type': 'string', 'Value': obj.Parameters[0].Value }]
			};

			_DWUtils2.default.sendJson(this.mWSSessions, msg);
			_DWUtils2.default.sendJson(this.mWSTasks, msg);
			_DWUtils2.default.sendJson(this.mWSReaders, msg);
		}
	}, {
		key: 'AttachToSessionCompleted',
		value: function AttachToSessionCompleted(obj) {
			if (obj.Parameters[0].Value === true) {

				if (_DWUtils2.default.DWMServerVersion !== 2) {
					_DWUtils2.default.sendJson(this.mWSSessions, {
						Method: 'SetDevicesAliases',
						Parameters: [{ 'Type': 'string[]', 'Value': ['', 'SAM'] }]
					});
				}

				if (this.options.useApiKey) {
					if (!this.options.apiKey) {
						_DWUtils2.default.log('No API key available. Protocol will likely bug.');
					}

					_DWUtils2.default.sendJson(this.mWSSessions, {
						Method: 'AuthenticateByAPIKeyAsync',
						Parameters: [{ 'Type': 'string', 'Value': this.options.apiKey }]
					});
				} else {
					_DWUtils2.default.sendJson(this.mWSSessions, {
						Method: 'AuthenticateAsync',
						Parameters: [{ 'Type': 'string', 'Value': this.options.login }, { 'Type': 'string', 'Value': this.options.password }]
					});
				}
			} else {
				_DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.ERROR, 'Attach to session failed !');
			}
		}
	}, {
		key: 'AuthenticateCompleted',
		value: function AuthenticateCompleted(obj) {
			if (obj.Parameters[0].Value === true) {
				if (this.options.taskId !== undefined && this.options.taskId.length !== 0) {
					this.mDWTasksProtocol.startTask(this.options.taskId);
				} else if (this.options.token !== undefined && this.options.token.length !== 0) {
					this.mDWTasksProtocol.startToken(this.options.token);
				} else {
					this.mDWTasksProtocol.getTaskList();
				}

				$('#showTasksButton').show();
			} else {
				_DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.ERROR, 'Authentication failed !');
			}
		}
	}, {
		key: 'CreateSessionAsync',
		value: function CreateSessionAsync() {
			if (_DWUtils2.default.DWMServerVersion === 2) {
				_DWUtils2.default.sendJson(this.mWSSessions, {
					Method: 'CreateSessionAsync'
				});
			} else {
				_DWUtils2.default.sendJson(this.mWSSessions, {
					Method: 'CreateSessionExAsync',
					Parameters: [{ 'Type': 'string', 'Value': '3.0.0.0' }, { 'Type': 'string', 'Value': this.options.clientName }, { 'Type': 'string', 'Value': this.options.stationName }]
				});
			}
		}
	}, {
		key: 'GetAPIVersionCompleted',
		value: function GetAPIVersionCompleted(obj) {
			//force api version 3
			if (obj.Parameters !== undefined) {
				obj.Parameters = _DWUtils2.default.convertProtocol(obj.Parameters);
			}
			_DWUtils2.default.DWMServerVersion = Number(obj.Parameters[0].Value.split('.', 1)[0]);

			if (_DWUtils2.default.DWMServerVersion !== 2 && _DWUtils2.default.DWMServerVersion !== 3) {
				_DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.ERROR, 'DataWriterClient does not support the server API: ' + obj.Parameters[0].Value);
			} else {
				this.CreateSessionAsync();
			}
		}
	}, {
		key: 'GetAPIVersionAsync',
		value: function GetAPIVersionAsync() {
			_DWUtils2.default.sendJson(this.mWSSessions, {
				Method: 'GetAPIVersionAsync'
			});
		}
	}, {
		key: 'DoIt',
		value: function DoIt(obj) {
			if ($.inArray(obj.Method, this.DWSessionsProtocolOperations) !== -1) {
				this[obj.Method](obj);
			} else {
				_DWUtils2.default.log('Sessions: Undefined method - ' + obj.Method);
			}
		}
	}, {
		key: 'TaskProtocol',
		set: function set(eDWTasksProtocol) {
			this.mDWTasksProtocol = eDWTasksProtocol;
		},
		get: function get() {
			return this.mDWTasksProtocol;
		}
	}, {
		key: 'WebSocketSessions',
		set: function set(eWSSocketSession) {
			this.mWSSessions = eWSSocketSession;
		},
		get: function get() {
			return this.mWSSessions;
		}
	}, {
		key: 'WebSocketTasks',
		set: function set(eWebSocketTask) {
			this.mWSTasks = eWebSocketTask;
		},
		get: function get() {
			return this.mWSTasks;
		}
	}, {
		key: 'WebSocketReaders',
		set: function set(eWebSocketReaders) {
			this.mWSReaders = eWebSocketReaders;
		},
		get: function get() {
			return this.mWSReaders;
		}
	}]);

	return DWSessionsProtocol;
}();

exports.default = DWSessionsProtocol;

},{"./DWUtils":4}],3:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*jshint esversion: 6 */

var _DWUtils = _dereq_('./DWUtils');

var _DWUtils2 = _interopRequireDefault(_DWUtils);

var _DWWebcam = _dereq_('./DWWebcam');

var _DWWebcam2 = _interopRequireDefault(_DWWebcam);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DWTasksProtocol = function () {
	function DWTasksProtocol(dwClient) {
		_classCallCheck(this, DWTasksProtocol);

		this.dwClient = dwClient;
		this.currentProcess = {};
		this.currentTaskId = undefined;
		this.DW_RECORD_FIELD_NAME = 'DwField';

		this.DWTasksProtocolOperations = Object.getOwnPropertyNames(DWTasksProtocol.prototype);
		this.DWMajorVersion = undefined;

		this.cardFront = undefined;
		this.cardBack = undefined;
	}

	_createClass(DWTasksProtocol, [{
		key: 'addMessageNotified',
		value: function addMessageNotified(obj) {
			var param = obj.Parameters;

			var type = _DWUtils2.default.DWTypeMsg.INFO;
			switch (param[2].Value) {
				case 0:
					type = _DWUtils2.default.DWTypeMsg.ERROR;
					break;
				case 1:
					type = _DWUtils2.default.DWTypeMsg.WARNING;
					break;
				case 2:
					type = _DWUtils2.default.DWTypeMsg.INFO;
					break;
			}

			_DWUtils2.default.addMessage(type, param[3].Value);
		}
	}, {
		key: 'AttachToSessionCompleted',
		value: function AttachToSessionCompleted(obj) {}
	}, {
		key: 'NotifyEncodingRecordMessageNotified',
		value: function NotifyEncodingRecordMessageNotified(obj) {
			this.addMessageNotified(obj);
		}
	}, {
		key: 'CurrentRecordChanged',
		value: function CurrentRecordChanged(obj) {
			$('#cardPreviewId').hide();
			$('#dwRecordFields').empty();
			$('#userValideButton').hide();

			var param = obj.Parameters;
			_DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.INFO, 'Current record changed: ' + param[1].Value);
		}
	}, {
		key: 'GetTaskListCompleted',
		value: function GetTaskListCompleted(obj) {
			var param = obj.Parameters;

			$('#dwTaskSelectorList').empty();
			param[0].Value.forEach(function (element) {
				var state = '';
				if (element.State === 1) {
					// Running
					state = ' list-group-item-success';
				}

				$('#dwTaskSelectorList').append('<button type="button" class="list-group-item' + state + '" onclick="dwWebClient.TaskProtocol.startTask(' + element.Identifier + ')">' + element.Identifier + ' - ' + element.Name + '</button>');
			});

			$('#dwTaskSelectorModal').modal('show');
		}
	}, {
		key: 'SetEncodingProcessConfiguration',
		value: function SetEncodingProcessConfiguration(obj) {
			this.currentProcess = obj.Parameters;
		}
	}, {
		key: 'NotifyCardPreview',
		value: function NotifyCardPreview(obj) {
			obj.Parameters.splice(1, 0, { 'Type': 'number', 'Value': 0 });
			if (obj.Parameters[2].Value) {
				obj.Parameters[2].Value = btoa(_DWUtils2.default.Uint8ToString(new Uint8Array(obj.Parameters[2].Value)));
			}
			if (obj.Parameters[3].Value) {
				obj.Parameters[3].Value = btoa(_DWUtils2.default.Uint8ToString(new Uint8Array(obj.Parameters[3].Value)));
			}

			this.NotifyCardPicture(obj);
		}
	}, {
		key: 'NotifyCardPicture',
		value: function NotifyCardPicture(obj) {
			var param = obj.Parameters;

			if (param[1].Value === 0) {
				//Preview
				if (param[2].Value) {
					$('#cardPreviewImgId').attr('src', 'data:image/bmp;base64,' + param[2].Value);
					$('#cardPreviewImgId').show();
					$('#cardPreviewId').show();
				}
				if (param[3].Value) {
					$('#cardPreviewImgBackId').attr('src', 'data:image/bmp;base64,' + param[3].Value);
					$('#cardPreviewImgBackId').show();
					$('#cardPreviewId').show();
				}
			} else if (param[1].Value === 1) {
				this.cardFront = param[2].Value;
				this.cardBack = param[3].Value;
			} else {
				_DWUtils2.default.log('NotifyCardPicture unknown type: ' + param[1].Value);
			}
		}
	}, {
		key: 'NotifyEncodingProcessStarted',
		value: function NotifyEncodingProcessStarted(obj) {}
	}, {
		key: 'SetTaskRecordConfiguration',
		value: function SetTaskRecordConfiguration(obj) {
			var param = obj.Parameters;
			var instance = this;
			param[1].Value.forEach(function (element) {
				if (element !== 2 && element !== 4) {
					//Encoding && Print
					_DWUtils2.default.sendJson(instance.mWSTasks, {
						Method: 'SetCurrentRecordActionStepState',
						Parameters: [{ 'Type': 'string', 'Value': instance.currentProcess[0].Value }, { 'Type': 'number', 'Value': element }, { 'Type': 'number', 'Value': 4 }] //NotAvailable
					});
				}
			});

			_DWUtils2.default.sendJson(this.mWSTasks, {
				Method: 'NotifyCurrentRecordClientIsReady',
				Parameters: [{ 'Type': 'string', 'Value': this.currentProcess[0].Value }]
			});
		}
	}, {
		key: 'SetCurrentRecordField',
		value: function SetCurrentRecordField(obj) {
			var param = obj.Parameters;

			var name = param[1].Value;

			var isReadOnly = param[4].Value;
			var currentValue = param[2].Value;
			var isNumber = Number.isInteger(param[2].Value);
			var min = 0;
			var max = param[3].Value;
			var displayName = param[6].Value.length === 0 ? param[1].Value : param[6].Value;
			var editor = param[5].Value;
			var src = '';
			var base64String;

			var field = document.getElementById(name + this.DW_RECORD_FIELD_NAME);
			if (field) {
				//we update it
				if (editor === undefined || editor === null) {
					field.value = currentValue;
				} else if (editor === 'Image') {
					if (this.mDWMajorVersion === 2) {
						base64String = btoa(String.fromCharCode.apply(null, new Uint8Array(currentValue)));
					} else {
						base64String = currentValue;
					}
					if (base64String.length !== 0) {
						src = 'data:image/png;base64,' + base64String;
					}
					field.src = src;
				}
			} else {

				var input = '';

				if (editor === undefined || editor === null) {

					input = '<input type="' + (isNumber ? 'number' : 'text') + '" class="form-control" id="' + name + this.DW_RECORD_FIELD_NAME + '" value="' + currentValue + '" ';
					if (max) {
						input += ' min="' + min + '" max="' + max + '"';
					}
					if (isReadOnly) {
						input += 'readonly';
					}
					input += '>';
				} else if (editor === 'Image') {

					if (this.mDWMajorVersion === 2) {
						base64String = btoa(String.fromCharCode.apply(null, new Uint8Array(currentValue)));
					} else {
						base64String = currentValue;
					}

					if (base64String.length !== 0) {
						src = 'data:image/png;base64,' + base64String;
					}

					input = '<div class="form-group">';
					input += '<img class="img-responsive" id="' + name + this.DW_RECORD_FIELD_NAME + '"  max="' + max + '" src="' + src + '" />';
					if (!isReadOnly) {
						input += '<input id="' + name + this.DW_RECORD_FIELD_NAME + 'FileButton" type="file" accept="image/*"/>';
						if (_DWWebcam2.default.hasUserMediaSupport()) {
							input += '<button id="' + name + this.DW_RECORD_FIELD_NAME + 'WebCamButton" type="button" class="btn btn-secondary" data-toggle="modal" data-target="#dwCameraModal">Webcam</button>';
						}
					}
					input += '</div>';
				}

				$('#dwRecordFields').append('<li class="list-group-item"> <div class="row"> <div class="col-md-4"> ' + displayName + ' </div> <div class="col-md-8"> ' + input + ' </div></div> </li>');

				if (editor === 'Image') {
					if (!isReadOnly) {
						if ($('#' + name + this.DW_RECORD_FIELD_NAME + 'WebCamButton') !== undefined) {
							$('#' + name + this.DW_RECORD_FIELD_NAME + 'WebCamButton').click(name + this.DW_RECORD_FIELD_NAME, function (event) {
								_DWWebcam2.default.initVideo(event.data);
							});
						}
						if ($('#' + name + this.DW_RECORD_FIELD_NAME + 'FileButton') !== undefined) {
							$('#' + name + this.DW_RECORD_FIELD_NAME + 'FileButton').change({ instance: this, fieldId: name + this.DW_RECORD_FIELD_NAME }, function (event) {
								_DWUtils2.default.getImageFromInputFile(this, event.data.fieldId);
							});
						}
					}
				}
			}
		}
	}, {
		key: 'UserInteractionAskedAsync',
		value: function UserInteractionAskedAsync(obj) {
			$('#userValideButton').show();
		}
	}, {
		key: 'GetCurrentRecordFieldValueAsync',
		value: function GetCurrentRecordFieldValueAsync(obj) {
			var name = obj.Parameters[1].Value;
			var field = document.getElementById(name + this.DW_RECORD_FIELD_NAME);

			var value;
			var type;
			if (field.type === 'number') {
				value = parseInt(field.value);
				type = 'number';
			} else if (field.type === 'text') {
				value = field.value;
				type = 'string';
			} else {
				//Image
				if (this.mDWMajorVersion === 2) {
					value = _DWUtils2.default.convertBase64ToArray(field.value);
				} else {
					value = _DWUtils2.default.removeBase64Tag(field.getAttribute('src'));
				}
				type = 'byte[]';
			}

			_DWUtils2.default.sendJson(this.mWSTasks, {
				Method: 'GetCurrentRecordFieldValueCompleted',
				Parameters: [{ 'Type': 'string', 'Value': this.currentProcess[0].Value }, _DWUtils2.default.getParamTypeJSON(value, type)]
			});
		}
	}, {
		key: 'NotifyWaitInsertion',
		value: function NotifyWaitInsertion(obj) {}
	}, {
		key: 'NotifyBeginRecordCreationStep',
		value: function NotifyBeginRecordCreationStep(obj) {}
	}, {
		key: 'NotifyWaitRemoval',
		value: function NotifyWaitRemoval(obj) {}
	}, {
		key: 'NotifyEndRecordCreationStep',
		value: function NotifyEndRecordCreationStep(obj) {}
	}, {
		key: 'CardErrorUserInteractionAskedAsync',
		value: function CardErrorUserInteractionAskedAsync(obj) {
			$('#dwCardErrorUserInteractionAskedModalLabel').html(obj.Parameters[1].Value);
			$('#dwCardErrorUserInteractionAskedModal').modal('show');
		}
	}, {
		key: 'NotifyEncodingMessageNotified',
		value: function NotifyEncodingMessageNotified(obj) {
			this.addMessageNotified(obj);
		}
	}, {
		key: 'ProcessClientCreationStepAsync',
		value: function ProcessClientCreationStepAsync(obj) {
			var type = obj.Parameters[1].Value;
			if (type === 4) {

				$('#cardPreviewImgModalId').hide();
				$('#cardPreviewImgBackModalId').hide();

				$('#dwPrintingModal').modal('show');

				$('#cardPreviewImgModalId').attr('src', $('#cardPreviewImgId').attr('src'));
				$('#cardPreviewImgBackModalId').attr('src', $('#cardPreviewImgBackId').attr('src'));

				if ($('#cardPreviewImgModalId').attr('src').length !== 0) {
					$('#cardPreviewImgModalId').show();
				}
				if ($('#cardPreviewImgBackModalId').attr('src').length !== 0) {
					$('#cardPreviewImgBackModalId').show();
				}
			}
		}
	}, {
		key: 'startTask',
		value: function startTask(mTaskId) {
			if (this.dwClient.dataWriterBridge !== null) {
				if (this.currentTaskId) {
					_DWUtils2.default.sendJson(this.mWSTasks, {
						Method: 'DetachTask',
						Parameters: [{ 'Type': 'number', 'Value': this.currentTaskId }]
					});

					this.currentTaskId = undefined;
				}
			}

			$('#dwTaskSelectorModal').modal('hide');

			if (this.dwClient.dataWriterBridge !== null) {
				_DWUtils2.default.sendJson(this.mWSTasks, {
					Method: _DWUtils2.default.DWMServerVersion === 3 ? 'StartEncodingTask' : 'StartEncodingProcess',
					Parameters: [{ 'Type': 'number', 'Value': mTaskId }]
				});
			} else {
				if ($.inArray('protocol', this.dwClient.options.deviceTech) !== -1) {
					var oHiddFrame = document.createElement('iframe');
					oHiddFrame.style.visibility = 'hidden';
					oHiddFrame.style.position = 'absolute';
					oHiddFrame.src = 'datawriter://' + btoa(this.dwClient.options.uri + '@' + this.dwClient.options.login + ':' + this.dwClient.options.password + '/' + mTaskId);
					document.body.appendChild(oHiddFrame);
				}
			}

			this.currentTaskId = mTaskId;
		}
	}, {
		key: 'startToken',
		value: function startToken(mToken) {
			$('#dwTaskSelectorModal').modal('hide');

			if (this.dwClient.dataWriterBridge !== null) {
				_DWUtils2.default.sendJson(this.mWSTasks, {
					Method: 'StartEncodingProcess',
					Parameters: [{ 'Type': 'string', 'Value': mToken }]
				});
			} else {
				if ($.inArray('protocol', this.dwClient.options.deviceTech) !== -1) {
					var oHiddFrame = document.createElement('iframe');
					oHiddFrame.style.visibility = 'hidden';
					oHiddFrame.style.position = 'absolute';
					oHiddFrame.src = 'datawriter://' + btoa(this.dwClient.options.uri + '@' + this.dwClient.options.login + ':' + this.dwClient.options.password + '/' + mToken);
					document.body.appendChild(oHiddFrame);
				}
			}
		}
	}, {
		key: 'getTaskList',
		value: function getTaskList() {
			if (this.mWSTasks !== null) {
				_DWUtils2.default.sendJson(this.mWSTasks, {
					Method: 'GetTaskListAsync'
				});
			}
		}
	}, {
		key: 'UserInteractionAskedCompleted',
		value: function UserInteractionAskedCompleted() {
			$('#dwRecordFields :input').attr('disabled', true);

			$('#userValideButton').hide();
			_DWUtils2.default.sendJson(this.mWSTasks, {
				Method: 'UserInteractionAskedCompleted',
				Parameters: [{ 'Type': 'string', 'Value': this.currentProcess[0].Value }]
			});
		}
	}, {
		key: 'CardErrorUserInteractionAskedCompleted',
		value: function CardErrorUserInteractionAskedCompleted(response) {
			var type = 0;
			switch (response) {
				case 'Retry':
					type = 1;
					break;
				case 'Cancel':
					type = 2;
					break;
				case 'Skip':
					type = 3;
					break;
			}
			_DWUtils2.default.sendJson(this.mWSTasks, {
				Method: 'CardErrorUserInteractionAskedCompleted',
				Parameters: [{ 'Type': 'string', 'Value': this.currentProcess[0].Value }, { 'Type': 'number', 'Value': type }]
			});
		}
	}, {
		key: 'ProcessClientCreationStepCompleted',
		value: function ProcessClientCreationStepCompleted() {
			_DWUtils2.default.sendJson(this.mWSTasks, {
				Method: 'ProcessClientCreationStepCompleted',
				Parameters: [{ 'Type': 'string', 'Value': this.currentProcess[0].Value }]
			});
		}
	}, {
		key: 'CancelPrintClientCreationStep',
		value: function CancelPrintClientCreationStep() {
			_DWUtils2.default.sendJson(this.mWSTasks, {
				Method: 'SetCurrentRecordActionStepState',
				Parameters: [{ 'Type': 'string', 'Value': this.currentProcess[0].Value }, { 'Type': 'number', 'Value': 4 }, { 'Type': 'number', 'Value': 2 }]
			});
			this.ProcessClientCreationStepCompleted();
		}
	}, {
		key: 'ProcessPrintClientCreationStep',
		value: function ProcessPrintClientCreationStep() {
			$('#dwPrintingModal').modal('hide');
			$('#cardPreviewImgModalId').attr('src', '');
			$('#cardPreviewImgBackModalId').attr('src', '');

			/* jshint ignore:start */
			function closePrint() {
				document.body.removeChild(this.__container__);
			}

			function setPrint() {
				this.contentWindow.__container__ = this;
				this.contentWindow.onbeforeunload = closePrint;
				this.contentWindow.onafterprint = closePrint;
				this.contentWindow.focus(); // Required for IE
				this.contentWindow.print();
			}
			/* jshint ignore:end */

			var pages = '<html><head><title>Card Image</title></head><body>';
			var imgCSS = '';
			var isChromium = window.chrome,
			    winNav = window.navigator,
			    vendorName = winNav.vendor,
			    isOpera = winNav.userAgent.indexOf('OPR') > -1,
			    isIEedge = winNav.userAgent.indexOf('Edge') > -1,
			    isIOSChrome = winNav.userAgent.match('CriOS');

			if (isChromium !== null && isChromium !== undefined && vendorName === 'Google Inc.' && isOpera === false && isIEedge === false) {
				pages += '<div style="position: absolute;  left: 0;  top: 0;  bottom: 0;  right: 0; margin: 0; padding: 0; display: block;">';
				imgCSS = 'width: 100%; height: 100%; margin: 0; padding: 0; display: block;';
			} else {
				pages += '<div style="position: absolute;  left: 0;  top: 0;  bottom: 0;  right: 0;">';
				imgCSS = 'width: 100%; height: 100%;';
			}

			pages += '<img style="' + imgCSS + '" src="data:image/bmp;base64,' + this.cardFront + '">';
			if (this.cardBack !== undefined && this.cardBack !== null) {
				pages += '<img style="' + imgCSS + '" src="data:image/bmp;base64,' + this.cardBack + '">';
			}
			pages += '</div></body></html>';

			var oHiddFrame = document.createElement('iframe');
			/* jshint ignore:start */
			oHiddFrame.onload = setPrint;
			/* jshint ignore:end */
			oHiddFrame.style.visibility = 'hidden';
			oHiddFrame.style.position = 'absolute';
			oHiddFrame.style.right = '0';
			oHiddFrame.style.bottom = '0';
			oHiddFrame.style.width = '100%';
			oHiddFrame.style.height = '100%';
			oHiddFrame.srcdoc = pages;
			document.body.appendChild(oHiddFrame);

			_DWUtils2.default.sendJson(this.mWSTasks, {
				Method: 'SetCurrentRecordActionStepState',
				Parameters: [{ 'Type': 'string', 'Value': this.currentProcess[0].Value }, { 'Type': 'number', 'Value': 4 }, { 'Type': 'number', 'Value': 1 }]
			});
			this.ProcessClientCreationStepCompleted();
		}
	}, {
		key: 'DoIt',
		value: function DoIt(obj) {
			if ($.inArray(obj.Method, this.DWTasksProtocolOperations) !== -1) {
				this[obj.Method](obj);
			} else {
				_DWUtils2.default.log('Tasks: Undefined method - ' + obj.Method);
			}
		}
	}, {
		key: 'WebSocketTasks',
		set: function set(eWebSocketTask) {
			this.mWSTasks = eWebSocketTask;
		},
		get: function get() {
			return this.mWSTasks;
		}
	}, {
		key: 'DWMajorVersion',
		set: function set(eDWMajorVersion) {
			this.mDWMajorVersion = eDWMajorVersion;
		},
		get: function get() {
			return this.mDWMajorVersion;
		}
	}]);

	return DWTasksProtocol;
}();

exports.default = DWTasksProtocol;

},{"./DWUtils":4,"./DWWebcam":5}],4:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/*jshint esversion: 6*/

var DWUtils = function () {
	function DWUtils() {
		_classCallCheck(this, DWUtils);
	}

	_createClass(DWUtils, null, [{
		key: 'getParamTypeJSON',
		value: function getParamTypeJSON(value, type) {

			if (type === undefined) {
				type = 'string';

				if (typeof value === 'boolean') {
					type = 'bool';
				} else if (typeof value === 'number') {
					type = 'number';
				}
			}

			return { 'Type': type, 'Value': value };
		}
	}, {
		key: 'convertProtocol',
		value: function convertProtocol(param) {
			var send = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;


			if (param !== undefined && param.length !== 0) {
				var paramConverted = [];
				var x = 0;
				while (x < param.length) {

					if (send === true) {
						if (param[x].Type !== undefined && DWUtils.DWMServerVersion === 2) {
							if (param[x].Type === 'byte[]') {
								param[x].Value = DWUtils.convertBase64ToArray(param[x].Value);
							}
							paramConverted.push(param[x].Value);
						} else {
							paramConverted.push(param[x]);
						}
					} else {
						//reception We are protocol > 2 so convert all
						if (param[x] === null || param[x] !== null && param[x].Type === undefined) {
							paramConverted.push(DWUtils.getParamTypeJSON(param[x]));
						} else {
							paramConverted.push(param[x]);
						}
					}

					++x;
				}
				param = paramConverted;
			}
			return param;
		}
	}, {
		key: 'addMessage',
		value: function addMessage(type, message) {
			var dwmessagesscroll = $('#dwmessagesscroll');
			var isScrolledToBottom = dwmessagesscroll.prop('scrollHeight') - dwmessagesscroll.prop('clientHeight') <= dwmessagesscroll.scrollTop() + 1;
			$('#dwmessages').append('<li class="list-group-item ' + type + '">' + message + '</li>');

			if (isScrolledToBottom) {
				dwmessagesscroll.scrollTop(dwmessagesscroll.prop('scrollHeight') - dwmessagesscroll.prop('clientHeight'));
			}
		}
	}, {
		key: 'sendJson',
		value: function sendJson(websocket, obj) {
			obj.Parameters = DWUtils.convertProtocol(obj.Parameters, true);
			var str = JSON.stringify(obj);
			DWUtils.log('Send: ' + str);
			websocket.send(str);
		}
	}, {
		key: 'removeBase64Tag',
		value: function removeBase64Tag(dataURI) {
			var BASE64_MARKER = ';base64,';
			if (dataURI.indexOf(BASE64_MARKER) !== -1) {
				var base64Index = dataURI.indexOf(BASE64_MARKER) + BASE64_MARKER.length;
				return dataURI.substring(base64Index);
			}
			return dataURI;
		}
	}, {
		key: 'convertBase64ToArray',
		value: function convertBase64ToArray(dataURI) {
			var BASE64_MARKER = ';base64,';
			var base64;
			if (dataURI.indexOf(BASE64_MARKER) !== -1) {
				var base64Index = dataURI.indexOf(BASE64_MARKER) + BASE64_MARKER.length;
				base64 = dataURI.substring(base64Index);
			} else {
				base64 = dataURI;
			}
			var raw = window.atob(base64);
			var byteNumbers = new Array(raw.length);
			for (var i = 0; i < raw.length; i++) {
				byteNumbers[i] = raw.charCodeAt(i);
			}
			return byteNumbers;
		}
	}, {
		key: 'resizeImage',
		value: function resizeImage(img, maxLength, callback) {
			var ratio = 1;

			var imgTmp = new Image();
			imgTmp.onload = function () {

				var array = DWUtils.convertBase64ToArray(imgTmp.src);
				DWUtils.log('array.length: ' + array.length + ' maxLength: ' + maxLength + ' ratio: ' + ratio);
				if (maxLength !== 0 && array.length > maxLength) {
					ratio *= 0.9;

					var canvas = document.createElement('canvas');
					var ctx = canvas.getContext('2d');
					canvas.width = img.width * ratio;
					canvas.height = img.height * ratio;
					ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
					imgTmp.src = canvas.toDataURL('image/jpeg', 0.3);
				} else {
					callback(imgTmp.src);
				}
			};

			imgTmp.src = img.src;
		}
	}, {
		key: 'log',
		value: function log(msg) {
			if (console && DWUtils.enableLog) {
				console.log(msg);
			}
		}
	}, {
		key: 'Uint8ToString',
		value: function Uint8ToString(u8a) {
			var CHUNK_SZ = 0x8000;
			var c = [];
			for (var i = 0; i < u8a.length; i += CHUNK_SZ) {
				c.push(String.fromCharCode.apply(null, u8a.subarray(i, i + CHUNK_SZ)));
			}
			return c.join('');
		}
	}, {
		key: 'getImageFromInputFile',
		value: function getImageFromInputFile(self, imgId) {
			if (self.files && self.files[0]) {
				var FR = new FileReader();
				FR.onload = function (e) {
					var img = document.getElementById(imgId);
					var maxLength = img.getAttribute('max');
					img.onload = function () {
						img.onload = null;
						DWUtils.resizeImage(img, maxLength, function (data) {
							img.src = data;
						});
					};
					img.src = e.target.result;
				};
				FR.readAsDataURL(self.files[0]);
			}
		}
	}]);

	return DWUtils;
}();

exports.default = DWUtils;


DWUtils.enableLog = true;

DWUtils.DWMServerVersion = 2;

DWUtils.DWTypeMsg = {
	NORMAL: '',
	SUCCESS: 'list-group-item-success',
	INFO: 'list-group-item-info',
	WARNING: 'list-group-item-warning',
	ERROR: 'list-group-item-danger'
};

},{}],5:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*jshint esversion: 6*/

var _DWUtils = _dereq_('./DWUtils');

var _DWUtils2 = _interopRequireDefault(_DWUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DWWebcam = function () {
  function DWWebcam() {
    _classCallCheck(this, DWWebcam);
  }

  _createClass(DWWebcam, null, [{
    key: 'initVideo',
    value: function initVideo(imgId) {

      var streaming = false,
          video = document.querySelector('#dwVideo'),
          cover = document.querySelector('#dwCover'),
          canvas = document.createElement('canvas'),
          startbutton = document.querySelector('#dwPictureCambutton'),
          videoObj = {
        'video': true
      },
          errBack = function errBack(error) {
        _DWUtils2.default.log('Video capture error: ' + error.code);
      },
          width = 320,
          height = 0,
          imgElement = document.getElementById(imgId);

      // Put video listeners into place
      if (navigator.getUserMedia) {
        // Standard
        navigator.getUserMedia(videoObj, function (stream) {
          video.src = stream;
          video.play();
        }, errBack);
      } else if (navigator.webkitGetUserMedia) {
        // WebKit-prefixed
        navigator.webkitGetUserMedia(videoObj, function (stream) {
          video.src = window.webkitURL.createObjectURL(stream);
          video.play();
        }, errBack);
      } else if (navigator.mozGetUserMedia) {
        // Firefox-prefixed
        navigator.mozGetUserMedia(videoObj, function (stream) {
          video.src = window.URL.createObjectURL(stream);
          video.play();
        }, errBack);
      }

      video.addEventListener('canplay', function (ev) {
        if (!streaming) {
          height = video.videoHeight / (video.videoWidth / width);
          video.setAttribute('width', width);
          video.setAttribute('height', height);
          canvas.setAttribute('width', width);
          canvas.setAttribute('height', height);
          streaming = true;
        }
      }, false);

      function takepicture() {
        canvas.width = width;
        canvas.height = height;
        canvas.getContext('2d').drawImage(video, 0, 0, width, height);
        var result = canvas.toDataURL('image/jpeg', 1.0);
        var maxLength = imgElement.getAttribute('max');

        imgElement.onload = function () {
          imgElement.onload = null;
          _DWUtils2.default.resizeImage(imgElement, maxLength, function (data) {
            imgElement.src = data;
          });
        };
        imgElement.src = result;
      }

      startbutton.addEventListener('click', function (ev) {
        takepicture();
        ev.preventDefault();
      }, false);
    }
  }, {
    key: 'hasUserMediaSupport',
    value: function hasUserMediaSupport() {
      if (navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia) {
        return true;
      }
      return false;
    }
  }]);

  return DWWebcam;
}();

exports.default = DWWebcam;

},{"./DWUtils":4}],6:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*jshint esversion: 6*/
/*jshint scripturl:true*/
/*jshint multistr:true*/

var _DWUtils = _dereq_('./DWUtils');

var _DWUtils2 = _interopRequireDefault(_DWUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DataWriterBridge = function () {
    function DataWriterBridge(bridgeOpt) {
        _classCallCheck(this, DataWriterBridge);

        this.reconnectBridge = false;

        this.bridgeOpt = bridgeOpt;
        this.bridgeSSLPort = bridgeOpt.SSLPort;
        this.bridgePort = bridgeOpt.port;
        // This is used to general to "protocol-url datawriter://"
        this.baseBridgeURL = bridgeOpt.baseURL;

        // Should the encoding client use SSL websocket to connect to the bridge.
        this.encodingClientToBridgeSSL = bridgeOpt.EncodingClientSSL;

        // Should the connection from browser to bridge be SSL.
        this.bridgeWSS = bridgeOpt.SSLEnabled;

        this.dataWriterBridgeWS = null; // WebSocket to the DataWriter Bridge.
        this.dwbContextId = ''; // Context Id on the bridge.
        this.mWSReaders = null;
        this.mCallback = null;
        this.binPath = '';

        // A message is sent by DW Bridge when the encoding
        // client join the context.
        this.encodingClientJoinedContext = false;
    }

    _createClass(DataWriterBridge, [{
        key: 'waitForSocketConnection',
        value: function waitForSocketConnection() {
            var _this = this;

            setTimeout(function () {
                if (!_this.dataWriterBridgeWS) {
                    return;
                }
                if (_this.dataWriterBridgeWS.readyState === 1 && _this.encodingClientJoinedContext) {
                    _DWUtils2.default.log('Successfully connected to the bridge.');
                    _this.mCallback();
                } else if (_this.dataWriterBridgeWS.readyState === 1) {
                    // Connected but encoding client didnt join yet.
                    _this.waitForSocketConnection();
                } else {
                    if (_this.dataWriterBridgeWS.readyState === 0) {
                        _DWUtils2.default.log('wait for connection...');
                        _this.waitForSocketConnection();
                    }
                }
            }, 1000); // wait 1000 milisecond for the connection...
        }

        /**
         * Generate a link (datawriter://) or link to a JNLP file
         * that will properly start the encoding wrt the current encoding
         * context.
         */

    }, {
        key: 'generateEncodingLink',
        value: function generateEncodingLink() {
            var dlUrl = '';

            // If using protocol mode.
            var protocolUrl = '';

            console.log('WSTYPE: ' + this.wsType);

            if (this.wsType === 'java') {
                // Full bridge url for encoding Java Client.
                var bridge_full_url = '';
                bridge_full_url += this.encodingClientToBridgeSSL ? 'wss://' : 'ws://';
                bridge_full_url += this.baseBridgeURL + ':';
                bridge_full_url += this.encodingClientToBridgeSSL ? this.bridgeSSLPort : this.bridgePort;
                bridge_full_url += '/encoder';

                // Url to a JS function that will generate and trigger the download of a
                // customized JNLP file.
                var jnlpCodeBase = this.binPath + '/jnlp';
                dlUrl = 'javascript:rfidonl.downloadCustomizedJNLP(\'' + bridge_full_url + '\', \'' + this.dwbContextId + '\', \'' + jnlpCodeBase + '\')';
            } else if (this.wsType === 'protocol') {
                // Protocol style require the download of the python encoder program.
                protocolUrl = 'datawriter://' + this.baseBridgeURL + ':' + (this.encodingClientToBridgeSSL ? this.bridgeSSLPort : this.bridgePort) + '/encoder/?contextId=' + this.dwbContextId;
                if (this.encodingClientToBridgeSSL) {
                    protocolUrl += '&wss=True';
                }

                launchInIFrame(protocolUrl);
                if (navigator.appVersion.indexOf('Win') !== -1 || true) {
                    dlUrl = this.binPath + '/DataWriterWebClient.exe';
                }
                protocolUrl = 'javascript:rfidonl.downloadProtocolUrl(\'' + protocolUrl + '\')';
            }

            if (dlUrl.length === 0) {
                _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.ERROR, 'Sorry, your OS is currently not supported.');
            } else {
                var msg = 'Please download and run the <a href="' + dlUrl + '">DataWriterWebClient</a> to enabled Web Encoding.';
                if (this.wsType === 'protocol') {
                    msg += ' Then click <a href="' + protocolUrl + '">here</a> to start the encoding client.';
                }
                _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.WARNING, msg);
            }
        }
    }, {
        key: 'reset',
        value: function reset() {
            if (this.dataWriterBridgeWS !== null) {
                this.dataWriterBridgeWS.onclose = null;
                this.dataWriterBridgeWS.close();
            }

            this.encodingClientJoinedContext = false;
            this.dataWriterBridgeWS = null;
        }
    }, {
        key: 'initSocket',
        value: function initSocket() {
            var _this2 = this;

            _DWUtils2.default.log('Connecting to DataWriter Bridge...');
            if (!this.reconnectBridge) {
                _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.INFO, 'Connecting to DataWriter Bridge...');
            }

            //this.dataWriterBridgeWS = new WebSocket('ws://127.0.0.1:27354/Reader');

            // NGINX reverse proxy for DWB
            this.dataWriterBridgeWS = new WebSocket((this.bridgeWSS ? 'wss://' : 'ws://') + this.baseBridgeURL + ':' + (this.bridgeWSS ? this.bridgeSSLPort : this.bridgePort) + '/browser');

            this.dataWriterBridgeWS.onopen = function () {
                _this2.reconnectBridge = false;

                _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.SUCCESS, 'Connected to DataWriter Bridge.');

                // Parameterless command to create+attach a context.
                _this2.dataWriterBridgeWS.send(JSON.stringify({
                    type: 'CMSGCreateContext'
                }));
            };
            this.dataWriterBridgeWS.onmessage = function (event) {
                //For now directly forward to reader server
                var obj = JSON.parse(event.data);

                if (obj.type && obj.type === 'SMSGCreateContext') {
                    console.log('DataWriter Bridge ContextId = ' + obj.content.context_id);
                    _this2.dwbContextId = obj.content.context_id;
                    _this2.generateEncodingLink();
                } else if (obj.type && obj.type === 'SMSGEncodingClientJoined') {
                    _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.SUCCESS, 'Encoding client joined context.');
                    _this2.encodingClientJoinedContext = true;
                } else if (obj.type && obj.type === 'SMSGEncodingClientLeft') {
                    _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.ERROR, 'Encoding client left. Please refresh the page.');
                } else {
                    _DWUtils2.default.log('Received from bridge: ' + event.data);
                    _DWUtils2.default.sendJson(_this2.mWSReaders, obj);
                }
            };
            this.dataWriterBridgeWS.onclose = function (event) {
                _DWUtils2.default.log('Disconnected from bridge. Reconnecting...');
                if (!_this2.reconnectBridge) {
                    _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.WARNING, 'Disconnected from bridge. Reconnecting...');
                }
                _this2.reconnectBridge = true;
                setTimeout(function () {
                    _this2.initSocket();
                }, 1000);
            };

            this.waitForSocketConnection();
        }
    }, {
        key: 'start',
        value: function start(wsType, binPath, callback) {
            this.wsType = wsType;
            this.binPath = binPath;
            this.mCallback = callback;
            this.encodingClientJoinedContext = false;

            this.initSocket();
        }
    }, {
        key: 'DataWriterBridgeWebSocket',
        get: function get() {
            return this.dataWriterBridgeWS;
        }
    }, {
        key: 'WebSocketReaders',
        get: function get() {
            return this.mWSReaders;
        },
        set: function set(eWebSocketReaders) {
            this.mWSReaders = eWebSocketReaders;
        }
    }], [{
        key: 'isSupported',
        value: function isSupported(wsType) {
            return true;
            // Java works everywhere, python binary (with protocol support) only work for windows for now.
            //return (wsType === 'java' || (wsType === 'protocol' && navigator.appVersion.indexOf('Win') !== -1));
        }
    }]);

    return DataWriterBridge;
}();

/**
 * Generate and start the download of a custom JNLP file
 * that is tailored to the current context.
 *
 *
 * IT WILL BE ANNOYING TO MAINTAINING THE BASE_JNLP BECAUSE IT
 * IS THE OUTPUT OF mvn COMMAND.
 *
 * This is the only way to pass custom parameter to the JNLP
 * backed program.
 */


exports.default = DataWriterBridge;
function downloadCustomizedJNLP(bridgeUrl, contextId, jnlpCodaBase) {
    var base_jnlp = '<?xml version="1.0" encoding="utf-8"?>\
<jnlp\
    spec="1.0+"\
    codebase="' + jnlpCodaBase + '" \
    >\
  <information>\
    <title>DataWriter Client Java</title>\
    <vendor>ISLOG</vendor>\
    <homepage href="http://www.islog.com/"/>\
    <description>$project.Description</description>\
  </information>\
  <security>\
     <all-permissions/>\
  </security>\
  <resources>\
    <j2se version="1.5+"/>\
\
    <jar href="lib/datawriterclient-java-1.1.jar" main="true"/>\
    <jar href="lib/tyrus-container-grizzly-server-1.12.jar"/>\
    <jar href="lib/grizzly-framework-2.3.22.jar"/>\
    <jar href="lib/grizzly-http-server-2.3.22.jar"/>\
    <jar href="lib/grizzly-http-2.3.22.jar"/>\
    <jar href="lib/tyrus-server-1.12.jar"/>\
    <jar href="lib/javax.websocket-api-1.1.jar"/>\
    <jar href="lib/tyrus-client-1.12.jar"/>\
    <jar href="lib/tyrus-core-1.12.jar"/>\
    <jar href="lib/tyrus-spi-1.12.jar"/>\
    <jar href="lib/tyrus-container-grizzly-client-1.12.jar"/>\
    <jar href="lib/gson-2.6.2.jar"/>\
\
  </resources>\
\
<application-desc main-class="com.islog.datawriter.client.DataWriterClient">\
    <argument>BRIDGE_URL_REPLACE_ME</argument>\
    <argument>CONTEXT_ID_REPLACE_ME</argument>\
</application-desc>\
</jnlp>';

    var jnlp_content = base_jnlp.replace('BRIDGE_URL_REPLACE_ME', bridgeUrl);
    jnlp_content = jnlp_content.replace('CONTEXT_ID_REPLACE_ME', contextId);

    var element = document.createElement('a');
    var blob = new Blob([jnlp_content], {
        type: 'text/jnlp'
    });
    var url = URL.createObjectURL(blob);
    element.href = url;
    element.setAttribute('download', 'encodingclient.jnlp');
    document.body.appendChild(element);
    element.click();
}

/**
 * Spawn the URL link into an iframe.
 * @param url
 */
function downloadProtocolUrl(url) {
    launchInIFrame(url);
}

function launchInIFrame(url) {
    var iFrame = $('<iframe/>').attr('class', 'launchFrame').attr('src', 'about:blank');
    iFrame.appendTo($('body'));
    iFrame.hide();
    try {
        iFrame[0].contentWindow.location.href = url;
    } catch (e) {}
}

// Great hack so we can reference the function easily from a
// <a href="javascript:..."> link.
window.rfidonl = window.rfidonl || {};
window.rfidonl.downloadCustomizedJNLP = downloadCustomizedJNLP;
window.rfidonl.downloadProtocolUrl = downloadProtocolUrl;

},{"./DWUtils":4}],7:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*jshint esversion: 6*/

var _DWUtils = _dereq_('./DWUtils');

var _DWUtils2 = _interopRequireDefault(_DWUtils);

var _DWReadersProtocol = _dereq_('./DWReadersProtocol');

var _DWReadersProtocol2 = _interopRequireDefault(_DWReadersProtocol);

var _DWSessionsProtocol = _dereq_('./DWSessionsProtocol');

var _DWSessionsProtocol2 = _interopRequireDefault(_DWSessionsProtocol);

var _DWTasksProtocol = _dereq_('./DWTasksProtocol');

var _DWTasksProtocol2 = _interopRequireDefault(_DWTasksProtocol);

var _DataWriterBridge = _dereq_('./DataWriterBridge');

var _DataWriterBridge2 = _interopRequireDefault(_DataWriterBridge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// For IE
Number.isInteger = Number.isInteger || function (value) {
    return typeof value === 'number' && isFinite(value) && Math.floor(value) === value;
};

/**
 * DataWriter Web Client to encode & print RFID / NFC cards.
 */

var DataWriterClient = function () {

    /**
     * Create a new DataWriter client instance.
     */
    function DataWriterClient() {
        _classCallCheck(this, DataWriterClient);

        // Make a copy of prototype.options to protect against overriding defaults
        this.options = $.extend({}, DataWriterClient.prototype.options);

        if (!window.WebSocket) {
            throw new Error('WebSocket is not supported.');
        }

        this.wsSessions = null;
        this.wsTasks = null;
        this.wsReaders = null;

        this.dwTaskProtocol = null;
        this.dwSessionsProtocol = null;
        this.dwReadersProtocol = null;

        this.dataWriterBridge = null;

        this.checkTimeout = null;
    }

    _createClass(DataWriterClient, [{
        key: 'checkDWSockets',
        value: function checkDWSockets() {
            var _this = this;

            if (this.wsSessions.readyState === 3 || this.wsTasks.readyState === 3 || this.wsReaders.readyState === 3) {
                _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.ERROR, 'Disconnect from DW Server.');
                this.resetUI();
                return;
            }

            this.checkTimeout = setTimeout(function () {
                _this.checkDWSockets();
            }, 3000);
        }
    }, {
        key: 'waitDWSockets',
        value: function waitDWSockets() {
            var _this2 = this;

            if (this.wsSessions.readyState !== 1 || this.wsTasks.readyState !== 1 || this.wsReaders.readyState !== 1 || this.dwSessionsProtocol.WebSocketTasks === null && this.dwSessionsProtocol.WebSocketSessions === null && this.dwSessionsProtocol.WebSocketReaders === null) {
                if (this.wsSessions.readyState === 3 || this.wsTasks.readyState === 3 || this.wsReaders.readyState === 3) {
                    _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.ERROR, 'Error while connecting to the server.');
                    this.reset();
                    return;
                }
                setTimeout(function () {
                    _this2.waitDWSockets();
                }, 1000);
            } else {
                _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.SUCCESS, 'Connection to server succeeded !');
                this.checkDWSockets();
                this.dwSessionsProtocol.GetAPIVersionAsync();
            }
        }
    }, {
        key: 'resetDWSockets',
        value: function resetDWSockets() {
            if (this.wsSessions !== null) {
                this.wsSessions.onclose = null;
                this.wsSessions.close();
            }
            if (this.wsTasks !== null) {
                this.wsTasks.onclose = null;
                this.wsTasks.close();
            }
            if (this.wsReaders !== null) {
                this.wsReaders.onclose = null;
                this.wsReaders.close();
            }

            this.wsTasks = this.wsReaders = this.wsSessions = null;
            if (this.checkTimeout !== null) {
                clearTimeout(this.checkTimeout);
            }
            this.checkTimeout = null;
        }
    }, {
        key: 'initDWSockets',
        value: function initDWSockets() {
            var _this3 = this;

            this.resetDWSockets();
            _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.INFO, 'Connection to server...');

            //Connect Sessions
            this.dwSessionsProtocol = new _DWSessionsProtocol2.default(this.options);
            _DWUtils2.default.log(this.options.uri + '/Sessions connecting...');
            this.wsSessions = new WebSocket(this.options.uri + '/Sessions');

            this.wsSessions.onopen = function () {
                _DWUtils2.default.log(_this3.options.uri + '/Sessions connected');
                _this3.dwSessionsProtocol.WebSocketSessions = _this3.wsSessions;
            };
            this.wsSessions.onmessage = function (event) {
                var obj = JSON.parse(event.data);
                _DWUtils2.default.log('Sessions: ' + event.data);

                obj.Parameters = _DWUtils2.default.convertProtocol(obj.Parameters);

                _this3.dwSessionsProtocol.DoIt(obj);
            };
            this.wsSessions.onclose = function (event) {
                _DWUtils2.default.log(_this3.options.uri + '/Sessions disconnected');
            };

            //Connect Tasks
            _DWUtils2.default.log(this.options.uri + '/Tasks connecting...');
            this.wsTasks = new WebSocket(this.options.uri + '/Tasks');

            this.wsTasks.onopen = function () {
                _DWUtils2.default.log(_this3.options.uri + '/Tasks connected');
                _this3.dwTaskProtocol = new _DWTasksProtocol2.default(_this3);

                _this3.dwTaskProtocol.WebSocketTasks = _this3.wsTasks;
                _this3.dwSessionsProtocol.TaskProtocol = _this3.dwTaskProtocol;
                _this3.dwSessionsProtocol.WebSocketTasks = _this3.wsTasks;
            };
            this.wsTasks.onmessage = function (event) {
                var obj = JSON.parse(event.data);
                _DWUtils2.default.log('Tasks: ' + event.data);

                obj.Parameters = _DWUtils2.default.convertProtocol(obj.Parameters);

                _this3.dwTaskProtocol.DoIt(obj);
            };
            this.wsTasks.onclose = function (event) {
                _DWUtils2.default.log(_this3.options.uri + '/Tasks disconnected');
            };

            //Connect Readers
            _DWUtils2.default.log(this.options.uri + '/Readers connecting...');
            this.wsReaders = new WebSocket(this.options.uri + '/Readers');

            this.wsReaders.onopen = function () {
                _DWUtils2.default.log(_this3.options.uri + '/Readers connected');
                _this3.dwReadersProtocol = new _DWReadersProtocol2.default();
                _this3.dwReadersProtocol.WebSocketReaders = _this3.wsReaders;
                if (_this3.dataWriterBridge !== null) {
                    _this3.dataWriterBridge.WebSocketReaders = _this3.wsReaders;
                    _this3.dwReadersProtocol.ProxyReader = _this3.dataWriterBridge.DataWriterBridgeWebSocket;
                }
                _this3.dwSessionsProtocol.WebSocketReaders = _this3.wsReaders;
            };
            this.wsReaders.onmessage = function (event) {
                var obj = JSON.parse(event.data);
                _DWUtils2.default.log('Readers: ' + event.data);
                _this3.dwReadersProtocol.DoIt(obj);
            };
            this.wsReaders.onclose = function (event) {
                _DWUtils2.default.log(_this3.options.uri + '/Readers disconnected');
            };

            this.waitDWSockets();
        }
    }, {
        key: 'resetUI',
        value: function resetUI() {
            $('#cardPreviewId').hide();
            $('#showTasksButton').hide();
            $('#dwRecordFields').empty();
            $('#userValideButton').hide();

            $('#dwCardErrorUserInteractionAskedModal').modal('hide');
            $('#dwPrintingModal').modal('hide');
            $('#dwTaskSelectorModal').modal('hide');
        }
    }, {
        key: 'reset',
        value: function reset() {
            this.debug();
            this.resetDWSockets();

            if (this.dataWriterBridge !== null) {
                this.dataWriterBridge.reset();
                this.dataWriterBridge = null;
            }
        }
    }, {
        key: 'debug',
        value: function debug() {
            var enabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

            _DWUtils2.default.enableLog = enabled;
            console.log('Debug status: ' + _DWUtils2.default.enableLog);
        }

        /**
         * Initialize the DataWriter client according to provided options.
         * @param {string[]} options - Client options.
         * @param {string[]} options[].deviceTech - Default order of rfid reader technology.
         * @param {string} options[].binPath - Binaries (exe file, ...) root path.
         * @param {string} options[].uri - DataWriter server address.
         * @param {string} options[].username - DataWriter username.
         * @param {string} options[].password - DataWriter password.
         * @param {string} options[].taskId - Default task identifier. If defined, the task will be started after successful authentication.
         * @param {string} options[].token - Encoding token. If defined, the process will be started after successful authentication.
            * @param options[].bridgeOpt -- bridge config options.
         */

    }, {
        key: 'init',
        value: function init(options) {
            var _this4 = this;

            // Updated options with supplied options
            this.options = $.extend(this.options, options);

            // if the global option object was accidentally blown away by
            // someone, bail early with an informative error
            if (!this.options || !this.options.deviceTech || !this.options.deviceTech.length) {
                throw new Error('No deviceTech specified.');
            }

            $('#collapseOne').collapse('show');
            $('#dwmessages').empty();

            console.log('Devices tech = ' + this.options.deviceTech);
            this.reset();
            var wsType = '';
            if ($.inArray('java', this.options.deviceTech) !== -1 && _DataWriterBridge2.default.isSupported('java')) {
                wsType = 'java';
            } else if ($.inArray('protocol', this.options.deviceTech) !== -1 && _DataWriterBridge2.default.isSupported('protocol')) {
                wsType = 'protocol';
            }

            if (wsType !== '') {
                this.dataWriterBridge = new _DataWriterBridge2.default(this.options.bridgeOpt);
                this.dataWriterBridge.start(wsType, this.options.binPath, function () {
                    _this4.resetUI();
                    _this4.initDWSockets();
                });
            } else {
                _DWUtils2.default.addMessage(_DWUtils2.default.DWTypeMsg.WARNING, 'No encoding technology enabled or available.');
            }
        }
    }, {
        key: 'TaskProtocol',
        get: function get() {
            return this.dwTaskProtocol;
        }
    }]);

    return DataWriterClient;
}();

/**
 * DataWriter Client options.
 */


DataWriterClient.prototype.options = {
    /**
     * Default order of rfid reader technology (java, protocol).
     */
    'deviceTech': ['java', 'protocol'],

    /**
     * Binaries (exe file, ...) root path.
     */
    'binPath': 'http://download.islog.com/datawriter/client/web2/',

    /**
     * DataWriter server address.
     */
    'uri': 'ws://demo.islog.com',

    /**
     * DataWriter username.
     */
    'username': 'demo',

    /**
     * DataWriter password.
     */
    'password': 'demo',

    /**
     * DataWriter Client Name (only used for API 3 >=).
     */
    'clientName': 'DataWriterClientJS' + (window.location.hostname !== '' ? ' ' + window.location.hostname : ''),

    /**
     * DataWriter Station Name (only used for API 3 >=).
     */
    'stationName': navigator.appName,

    /**
     * Default task identifier. If defined, the task will be started after successful authentication.
     */
    'taskId': undefined,

    /**
     * Encoding token. If defined, the process will be started after successful authentication.
     */
    'token': undefined,

    'bridgeOpt': {
        'SSLPort': 4040,
        'port': 4444,
        'SSLEnabled': false, // SSL browser to bridge
        'EncodingClientSSL': false, // SSL, encoding client to bridge.
        'baseURL': 'rfid.onl'
    }
};

exports.default = DataWriterClient;

},{"./DWReadersProtocol":1,"./DWSessionsProtocol":2,"./DWTasksProtocol":3,"./DWUtils":4,"./DataWriterBridge":6}],8:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; /*jshint esversion: 6*/

var _DataWriterClient = _dereq_('./DataWriterClient');

var _DataWriterClient2 = _interopRequireDefault(_DataWriterClient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create a new DataWriter client instance.
 */
var dwjs = function dwjs() {
    return new _DataWriterClient2.default();
};

/* jshint ignore:start */
/**
 * Custom Universal Module Definition (UMD)
 */
(function (root, factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define('dwjs', [], factory);
    } else if ((typeof exports === 'undefined' ? 'undefined' : _typeof(exports)) === 'object') {
        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        module.exports = factory();
    } else {
        // Browser globals (root is window)
        root.dwjs = factory();
    }
})(undefined, function () {
    // Just return a value to define the module export.
    return dwjs;
});

exports.default = dwjs;
/* jshint ignore:end */

},{"./DataWriterClient":7}]},{},[8])(8)
});
//# sourceMappingURL=datawriterclient.js.map
